# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from fetch_driver_msgs/GripperState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import fetch_driver_msgs.msg
import std_msgs.msg

class GripperState(genpy.Message):
  _md5sum = "3b442b195034293254bd9964c5dac688"
  _type = "fetch_driver_msgs/GripperState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """#
# Primary message for a gripper
#

Header header

bool ready
bool faulted

BoardState[] boards
MotorState[] motors
JointState[] joints

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: fetch_driver_msgs/BoardState
string name

int32 board_type
int16 board_revision
int16 software_revision

int8 boot_status
uint16 board_flags

uint64 system_time

float32 voltage
float32 temperature

uint32 packets_sent
uint32 packets_recv
uint32 packets_bad
uint32 packets_back

================================================================================
MSG: fetch_driver_msgs/MotorState
# TODO add motor state/error definitions

string name

uint8 state
uint8 error

float32 velocity
float32 effort
float32 position

float32 temperature

# TODO: velocity/position gains

float32 motor_ratio
float32 motor_angle_offset
float32 motor_angle_offset_estimated
float32 joint_ratio

================================================================================
MSG: fetch_driver_msgs/JointState
string name

uint8 control_mode

float32 desired_position
float32 desired_velocity
float32 desired_effort

float32 position
float32 velocity
float32 effort
"""
  __slots__ = ['header','ready','faulted','boards','motors','joints']
  _slot_types = ['std_msgs/Header','bool','bool','fetch_driver_msgs/BoardState[]','fetch_driver_msgs/MotorState[]','fetch_driver_msgs/JointState[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,ready,faulted,boards,motors,joints

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GripperState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.ready is None:
        self.ready = False
      if self.faulted is None:
        self.faulted = False
      if self.boards is None:
        self.boards = []
      if self.motors is None:
        self.motors = []
      if self.joints is None:
        self.joints = []
    else:
      self.header = std_msgs.msg.Header()
      self.ready = False
      self.faulted = False
      self.boards = []
      self.motors = []
      self.joints = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.ready, _x.faulted))
      length = len(self.boards)
      buff.write(_struct_I.pack(length))
      for val1 in self.boards:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_get_struct_i2hbHQ2f4I().pack(_x.board_type, _x.board_revision, _x.software_revision, _x.boot_status, _x.board_flags, _x.system_time, _x.voltage, _x.temperature, _x.packets_sent, _x.packets_recv, _x.packets_bad, _x.packets_back))
      length = len(self.motors)
      buff.write(_struct_I.pack(length))
      for val1 in self.motors:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_get_struct_2B8f().pack(_x.state, _x.error, _x.velocity, _x.effort, _x.position, _x.temperature, _x.motor_ratio, _x.motor_angle_offset, _x.motor_angle_offset_estimated, _x.joint_ratio))
      length = len(self.joints)
      buff.write(_struct_I.pack(length))
      for val1 in self.joints:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_get_struct_B6f().pack(_x.control_mode, _x.desired_position, _x.desired_velocity, _x.desired_effort, _x.position, _x.velocity, _x.effort))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.boards is None:
        self.boards = None
      if self.motors is None:
        self.motors = None
      if self.joints is None:
        self.joints = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.ready, _x.faulted,) = _get_struct_2B().unpack(str[start:end])
      self.ready = bool(self.ready)
      self.faulted = bool(self.faulted)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.boards = []
      for i in range(0, length):
        val1 = fetch_driver_msgs.msg.BoardState()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 43
        (_x.board_type, _x.board_revision, _x.software_revision, _x.boot_status, _x.board_flags, _x.system_time, _x.voltage, _x.temperature, _x.packets_sent, _x.packets_recv, _x.packets_bad, _x.packets_back,) = _get_struct_i2hbHQ2f4I().unpack(str[start:end])
        self.boards.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.motors = []
      for i in range(0, length):
        val1 = fetch_driver_msgs.msg.MotorState()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 34
        (_x.state, _x.error, _x.velocity, _x.effort, _x.position, _x.temperature, _x.motor_ratio, _x.motor_angle_offset, _x.motor_angle_offset_estimated, _x.joint_ratio,) = _get_struct_2B8f().unpack(str[start:end])
        self.motors.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joints = []
      for i in range(0, length):
        val1 = fetch_driver_msgs.msg.JointState()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 25
        (_x.control_mode, _x.desired_position, _x.desired_velocity, _x.desired_effort, _x.position, _x.velocity, _x.effort,) = _get_struct_B6f().unpack(str[start:end])
        self.joints.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.ready, _x.faulted))
      length = len(self.boards)
      buff.write(_struct_I.pack(length))
      for val1 in self.boards:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_get_struct_i2hbHQ2f4I().pack(_x.board_type, _x.board_revision, _x.software_revision, _x.boot_status, _x.board_flags, _x.system_time, _x.voltage, _x.temperature, _x.packets_sent, _x.packets_recv, _x.packets_bad, _x.packets_back))
      length = len(self.motors)
      buff.write(_struct_I.pack(length))
      for val1 in self.motors:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_get_struct_2B8f().pack(_x.state, _x.error, _x.velocity, _x.effort, _x.position, _x.temperature, _x.motor_ratio, _x.motor_angle_offset, _x.motor_angle_offset_estimated, _x.joint_ratio))
      length = len(self.joints)
      buff.write(_struct_I.pack(length))
      for val1 in self.joints:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_get_struct_B6f().pack(_x.control_mode, _x.desired_position, _x.desired_velocity, _x.desired_effort, _x.position, _x.velocity, _x.effort))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.boards is None:
        self.boards = None
      if self.motors is None:
        self.motors = None
      if self.joints is None:
        self.joints = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.ready, _x.faulted,) = _get_struct_2B().unpack(str[start:end])
      self.ready = bool(self.ready)
      self.faulted = bool(self.faulted)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.boards = []
      for i in range(0, length):
        val1 = fetch_driver_msgs.msg.BoardState()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 43
        (_x.board_type, _x.board_revision, _x.software_revision, _x.boot_status, _x.board_flags, _x.system_time, _x.voltage, _x.temperature, _x.packets_sent, _x.packets_recv, _x.packets_bad, _x.packets_back,) = _get_struct_i2hbHQ2f4I().unpack(str[start:end])
        self.boards.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.motors = []
      for i in range(0, length):
        val1 = fetch_driver_msgs.msg.MotorState()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 34
        (_x.state, _x.error, _x.velocity, _x.effort, _x.position, _x.temperature, _x.motor_ratio, _x.motor_angle_offset, _x.motor_angle_offset_estimated, _x.joint_ratio,) = _get_struct_2B8f().unpack(str[start:end])
        self.motors.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joints = []
      for i in range(0, length):
        val1 = fetch_driver_msgs.msg.JointState()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 25
        (_x.control_mode, _x.desired_position, _x.desired_velocity, _x.desired_effort, _x.position, _x.velocity, _x.effort,) = _get_struct_B6f().unpack(str[start:end])
        self.joints.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_2B8f = None
def _get_struct_2B8f():
    global _struct_2B8f
    if _struct_2B8f is None:
        _struct_2B8f = struct.Struct("<2B8f")
    return _struct_2B8f
_struct_i2hbHQ2f4I = None
def _get_struct_i2hbHQ2f4I():
    global _struct_i2hbHQ2f4I
    if _struct_i2hbHQ2f4I is None:
        _struct_i2hbHQ2f4I = struct.Struct("<i2hbHQ2f4I")
    return _struct_i2hbHQ2f4I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_B6f = None
def _get_struct_B6f():
    global _struct_B6f
    if _struct_B6f is None:
        _struct_B6f = struct.Struct("<B6f")
    return _struct_B6f
