# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from fetch_driver_msgs/MotorState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class MotorState(genpy.Message):
  _md5sum = "b726a0cde2dd21efcdc6db33af6de8d2"
  _type = "fetch_driver_msgs/MotorState"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# TODO add motor state/error definitions

string name

uint8 state
uint8 error

float32 velocity
float32 effort
float32 position

float32 temperature

# TODO: velocity/position gains

float32 motor_ratio
float32 motor_angle_offset
float32 motor_angle_offset_estimated
float32 joint_ratio
"""
  __slots__ = ['name','state','error','velocity','effort','position','temperature','motor_ratio','motor_angle_offset','motor_angle_offset_estimated','joint_ratio']
  _slot_types = ['string','uint8','uint8','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,state,error,velocity,effort,position,temperature,motor_ratio,motor_angle_offset,motor_angle_offset_estimated,joint_ratio

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MotorState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.state is None:
        self.state = 0
      if self.error is None:
        self.error = 0
      if self.velocity is None:
        self.velocity = 0.
      if self.effort is None:
        self.effort = 0.
      if self.position is None:
        self.position = 0.
      if self.temperature is None:
        self.temperature = 0.
      if self.motor_ratio is None:
        self.motor_ratio = 0.
      if self.motor_angle_offset is None:
        self.motor_angle_offset = 0.
      if self.motor_angle_offset_estimated is None:
        self.motor_angle_offset_estimated = 0.
      if self.joint_ratio is None:
        self.joint_ratio = 0.
    else:
      self.name = ''
      self.state = 0
      self.error = 0
      self.velocity = 0.
      self.effort = 0.
      self.position = 0.
      self.temperature = 0.
      self.motor_ratio = 0.
      self.motor_angle_offset = 0.
      self.motor_angle_offset_estimated = 0.
      self.joint_ratio = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2B8f().pack(_x.state, _x.error, _x.velocity, _x.effort, _x.position, _x.temperature, _x.motor_ratio, _x.motor_angle_offset, _x.motor_angle_offset_estimated, _x.joint_ratio))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 34
      (_x.state, _x.error, _x.velocity, _x.effort, _x.position, _x.temperature, _x.motor_ratio, _x.motor_angle_offset, _x.motor_angle_offset_estimated, _x.joint_ratio,) = _get_struct_2B8f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2B8f().pack(_x.state, _x.error, _x.velocity, _x.effort, _x.position, _x.temperature, _x.motor_ratio, _x.motor_angle_offset, _x.motor_angle_offset_estimated, _x.joint_ratio))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 34
      (_x.state, _x.error, _x.velocity, _x.effort, _x.position, _x.temperature, _x.motor_ratio, _x.motor_angle_offset, _x.motor_angle_offset_estimated, _x.joint_ratio,) = _get_struct_2B8f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B8f = None
def _get_struct_2B8f():
    global _struct_2B8f
    if _struct_2B8f is None:
        _struct_2B8f = struct.Struct("<2B8f")
    return _struct_2B8f
