// Auto-generated. Do not edit!

// (in-package fetch_driver_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let BoardState = require('./BoardState.js');
let MotorState = require('./MotorState.js');
let JointState = require('./JointState.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class GripperState {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.ready = null;
      this.faulted = null;
      this.boards = null;
      this.motors = null;
      this.joints = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('ready')) {
        this.ready = initObj.ready
      }
      else {
        this.ready = false;
      }
      if (initObj.hasOwnProperty('faulted')) {
        this.faulted = initObj.faulted
      }
      else {
        this.faulted = false;
      }
      if (initObj.hasOwnProperty('boards')) {
        this.boards = initObj.boards
      }
      else {
        this.boards = [];
      }
      if (initObj.hasOwnProperty('motors')) {
        this.motors = initObj.motors
      }
      else {
        this.motors = [];
      }
      if (initObj.hasOwnProperty('joints')) {
        this.joints = initObj.joints
      }
      else {
        this.joints = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GripperState
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [ready]
    bufferOffset = _serializer.bool(obj.ready, buffer, bufferOffset);
    // Serialize message field [faulted]
    bufferOffset = _serializer.bool(obj.faulted, buffer, bufferOffset);
    // Serialize message field [boards]
    // Serialize the length for message field [boards]
    bufferOffset = _serializer.uint32(obj.boards.length, buffer, bufferOffset);
    obj.boards.forEach((val) => {
      bufferOffset = BoardState.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [motors]
    // Serialize the length for message field [motors]
    bufferOffset = _serializer.uint32(obj.motors.length, buffer, bufferOffset);
    obj.motors.forEach((val) => {
      bufferOffset = MotorState.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [joints]
    // Serialize the length for message field [joints]
    bufferOffset = _serializer.uint32(obj.joints.length, buffer, bufferOffset);
    obj.joints.forEach((val) => {
      bufferOffset = JointState.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GripperState
    let len;
    let data = new GripperState(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [ready]
    data.ready = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [faulted]
    data.faulted = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [boards]
    // Deserialize array length for message field [boards]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.boards = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.boards[i] = BoardState.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [motors]
    // Deserialize array length for message field [motors]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.motors = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.motors[i] = MotorState.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [joints]
    // Deserialize array length for message field [joints]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.joints = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.joints[i] = JointState.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.boards.forEach((val) => {
      length += BoardState.getMessageSize(val);
    });
    object.motors.forEach((val) => {
      length += MotorState.getMessageSize(val);
    });
    object.joints.forEach((val) => {
      length += JointState.getMessageSize(val);
    });
    return length + 14;
  }

  static datatype() {
    // Returns string type for a message object
    return 'fetch_driver_msgs/GripperState';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3b442b195034293254bd9964c5dac688';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    #
    # Primary message for a gripper
    #
    
    Header header
    
    bool ready
    bool faulted
    
    BoardState[] boards
    MotorState[] motors
    JointState[] joints
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: fetch_driver_msgs/BoardState
    string name
    
    int32 board_type
    int16 board_revision
    int16 software_revision
    
    int8 boot_status
    uint16 board_flags
    
    uint64 system_time
    
    float32 voltage
    float32 temperature
    
    uint32 packets_sent
    uint32 packets_recv
    uint32 packets_bad
    uint32 packets_back
    
    ================================================================================
    MSG: fetch_driver_msgs/MotorState
    # TODO add motor state/error definitions
    
    string name
    
    uint8 state
    uint8 error
    
    float32 velocity
    float32 effort
    float32 position
    
    float32 temperature
    
    # TODO: velocity/position gains
    
    float32 motor_ratio
    float32 motor_angle_offset
    float32 motor_angle_offset_estimated
    float32 joint_ratio
    
    ================================================================================
    MSG: fetch_driver_msgs/JointState
    string name
    
    uint8 control_mode
    
    float32 desired_position
    float32 desired_velocity
    float32 desired_effort
    
    float32 position
    float32 velocity
    float32 effort
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GripperState(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.ready !== undefined) {
      resolved.ready = msg.ready;
    }
    else {
      resolved.ready = false
    }

    if (msg.faulted !== undefined) {
      resolved.faulted = msg.faulted;
    }
    else {
      resolved.faulted = false
    }

    if (msg.boards !== undefined) {
      resolved.boards = new Array(msg.boards.length);
      for (let i = 0; i < resolved.boards.length; ++i) {
        resolved.boards[i] = BoardState.Resolve(msg.boards[i]);
      }
    }
    else {
      resolved.boards = []
    }

    if (msg.motors !== undefined) {
      resolved.motors = new Array(msg.motors.length);
      for (let i = 0; i < resolved.motors.length; ++i) {
        resolved.motors[i] = MotorState.Resolve(msg.motors[i]);
      }
    }
    else {
      resolved.motors = []
    }

    if (msg.joints !== undefined) {
      resolved.joints = new Array(msg.joints.length);
      for (let i = 0; i < resolved.joints.length; ++i) {
        resolved.joints[i] = JointState.Resolve(msg.joints[i]);
      }
    }
    else {
      resolved.joints = []
    }

    return resolved;
    }
};

module.exports = GripperState;
