// Auto-generated. Do not edit!

// (in-package fetch_driver_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Gyro {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.flags = null;
      this.data = null;
      this.raw = null;
      this.scale = null;
      this.offset = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('flags')) {
        this.flags = initObj.flags
      }
      else {
        this.flags = 0;
      }
      if (initObj.hasOwnProperty('data')) {
        this.data = initObj.data
      }
      else {
        this.data = new geometry_msgs.msg.Vector3();
      }
      if (initObj.hasOwnProperty('raw')) {
        this.raw = initObj.raw
      }
      else {
        this.raw = new geometry_msgs.msg.Vector3();
      }
      if (initObj.hasOwnProperty('scale')) {
        this.scale = initObj.scale
      }
      else {
        this.scale = new geometry_msgs.msg.Vector3();
      }
      if (initObj.hasOwnProperty('offset')) {
        this.offset = initObj.offset
      }
      else {
        this.offset = new geometry_msgs.msg.Vector3();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Gyro
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [flags]
    bufferOffset = _serializer.uint32(obj.flags, buffer, bufferOffset);
    // Serialize message field [data]
    bufferOffset = geometry_msgs.msg.Vector3.serialize(obj.data, buffer, bufferOffset);
    // Serialize message field [raw]
    bufferOffset = geometry_msgs.msg.Vector3.serialize(obj.raw, buffer, bufferOffset);
    // Serialize message field [scale]
    bufferOffset = geometry_msgs.msg.Vector3.serialize(obj.scale, buffer, bufferOffset);
    // Serialize message field [offset]
    bufferOffset = geometry_msgs.msg.Vector3.serialize(obj.offset, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Gyro
    let len;
    let data = new Gyro(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [flags]
    data.flags = _deserializer.uint32(buffer, bufferOffset);
    // Deserialize message field [data]
    data.data = geometry_msgs.msg.Vector3.deserialize(buffer, bufferOffset);
    // Deserialize message field [raw]
    data.raw = geometry_msgs.msg.Vector3.deserialize(buffer, bufferOffset);
    // Deserialize message field [scale]
    data.scale = geometry_msgs.msg.Vector3.deserialize(buffer, bufferOffset);
    // Deserialize message field [offset]
    data.offset = geometry_msgs.msg.Vector3.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 100;
  }

  static datatype() {
    // Returns string type for a message object
    return 'fetch_driver_msgs/Gyro';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7e55d268dcc35aae7026f0428ed61292';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    Header header
    
    uint32 flags
    
    # Scaled and offset gyro axis values
    geometry_msgs/Vector3 data
    
    # Raw data from gyro (unscaled, and unofffset) 
    geometry_msgs/Vector3 raw
    
    # Scale values used for each axis
    geometry_msgs/Vector3 scale
    
    # Offset value used for each axis
    geometry_msgs/Vector3 offset
    
    
    # Glitch was detected
    uint32 GLITCH = 1
    
    # Problem initializing gyro
    uint32 INIT_ERROR = 2
    
    # Error reading data
    uint32 READ_ERROR = 4
    
    # Interrupt for new data is not being triggered fast enough
    uint32 INTERRUPT_TOO_SLOW = 8
    
    # Interrupt for new data is being triggrered to quickly
    uint32 INTERRUPT_TOO_FAST = 16
    
    # No sensor is availble
    uint32 SENSOR_NOT_PRESENT = 32
    
    # Robot is definitely moving, gyro output should be non-zero 
    uint32 DEFINITELY_MOVING = 536870912   # 1<<29
    
    # Robot is definitely stopped, gyro offset can be adjusted
    uint32 DEFINITELY_STOPPED = 1073741824   # 1<<30
    
    # Robot gyro has any type of error, can be used for ignoring
    # invalid gyro data even without understanding any specific
    # error types
    uint32 ANY_ERROR = 2147483648   # 1<<31
    
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Gyro(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.flags !== undefined) {
      resolved.flags = msg.flags;
    }
    else {
      resolved.flags = 0
    }

    if (msg.data !== undefined) {
      resolved.data = geometry_msgs.msg.Vector3.Resolve(msg.data)
    }
    else {
      resolved.data = new geometry_msgs.msg.Vector3()
    }

    if (msg.raw !== undefined) {
      resolved.raw = geometry_msgs.msg.Vector3.Resolve(msg.raw)
    }
    else {
      resolved.raw = new geometry_msgs.msg.Vector3()
    }

    if (msg.scale !== undefined) {
      resolved.scale = geometry_msgs.msg.Vector3.Resolve(msg.scale)
    }
    else {
      resolved.scale = new geometry_msgs.msg.Vector3()
    }

    if (msg.offset !== undefined) {
      resolved.offset = geometry_msgs.msg.Vector3.Resolve(msg.offset)
    }
    else {
      resolved.offset = new geometry_msgs.msg.Vector3()
    }

    return resolved;
    }
};

// Constants for message
Gyro.Constants = {
  GLITCH: 1,
  INIT_ERROR: 2,
  READ_ERROR: 4,
  INTERRUPT_TOO_SLOW: 8,
  INTERRUPT_TOO_FAST: 16,
  SENSOR_NOT_PRESENT: 32,
  DEFINITELY_MOVING: 536870912,
  DEFINITELY_STOPPED: 1073741824,
  ANY_ERROR: 2147483648,
}

module.exports = Gyro;
